ros-kilted-controller-manager (5.8.2-1noble) noble; urgency=high

  * Avoid deadlocks for failed command switching (#2774 <https://github.com/ros-controls/ros2_control/issues/2774>) (#2797 <https://github.com/ros-controls/ros2_control/issues/2797>)
  * Fix ANSI escape code pollution in log output (backport #2741 <https://github.com/ros-controls/ros2_control/issues/2741>) (#2784 <https://github.com/ros-controls/ros2_control/issues/2784>)
  * Contributors: mergify[bot]

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 09 Nov 2025 00:00:00 -0000

ros-kilted-controller-manager (5.8.1-1noble) noble; urgency=high

  * Fail early for the resource conflicts between the activating controllers (#2760 <https://github.com/ros-controls/ros2_control/issues/2760>) (#2773 <https://github.com/ros-controls/ros2_control/issues/2773>)
  * Contributors: mergify[bot]

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 03 Nov 2025 00:00:00 -0000

ros-kilted-controller-manager (5.8.0-1noble) noble; urgency=high

  * Deactivate the whole controller chain if one of the update results in ERROR (#2681 <https://github.com/ros-controls/ros2_control/issues/2681>) (#2744 <https://github.com/ros-controls/ros2_control/issues/2744>)
  * Deactivate the controller chain upon failed group activation (#2669 <https://github.com/ros-controls/ros2_control/issues/2669>) (#2738 <https://github.com/ros-controls/ros2_control/issues/2738>)
  * Fix concurrent spinning of the test_node (backport #2721 <https://github.com/ros-controls/ros2_control/issues/2721>) (#2728 <https://github.com/ros-controls/ros2_control/issues/2728>)
  * [Spawner] Fix failing makedirs on multiple spawners at startup (#2698 <https://github.com/ros-controls/ros2_control/issues/2698>) (#2700 <https://github.com/ros-controls/ros2_control/issues/2700>)
  * [Spawner] Create the FileLock in the ROS_HOME location (#2677 <https://github.com/ros-controls/ros2_control/issues/2677>) (#2686 <https://github.com/ros-controls/ros2_control/issues/2686>)
  * Fix the same hardware component node naming issue with multiple controller managers setup (#2657 <https://github.com/ros-controls/ros2_control/issues/2657>) (#2667 <https://github.com/ros-controls/ros2_control/issues/2667>)
  * Move clock availability check to controller manager thread (#2654 <https://github.com/ros-controls/ros2_control/issues/2654>) (#2661 <https://github.com/ros-controls/ros2_control/issues/2661>)
  * increase tolerance of the controller manager tests (#2629 <https://github.com/ros-controls/ros2_control/issues/2629>) (#2637 <https://github.com/ros-controls/ros2_control/issues/2637>)
  * [Controllers] Set async thread properties via parameters (#2613 <https://github.com/ros-controls/ros2_control/issues/2613>)
  * Contributors: Sai Kishor Kothakota, mergify[bot]

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 27 Oct 2025 00:00:00 -0000

ros-kilted-controller-manager (5.7.0-1noble) noble; urgency=high

  * [CM] Ability to switch controllers in non-realtime loop (#2452 <https://github.com/ros-controls/ros2_control/issues/2452>)
  * Added parameters to handle the overruns behaviour and prints (#2546 <https://github.com/ros-controls/ros2_control/issues/2546>)
  * [Controllers] Receive a valid period on the first update cycle (#2572 <https://github.com/ros-controls/ros2_control/issues/2572>)
  * Add ControllerInterfaceParams to initialize the Controllers (#2390 <https://github.com/ros-controls/ros2_control/issues/2390>)
  * Add parameter to allow controllers with inactive hardware components (#2501 <https://github.com/ros-controls/ros2_control/issues/2501>)
  * Fix exclusive hardware control mode switching on controller failed activation (#1522 <https://github.com/ros-controls/ros2_control/issues/1522>)
  * Fix the skipped cycles of controllers running at different rate (#2557 <https://github.com/ros-controls/ros2_control/issues/2557>)
  * Fix shadowed variables, redefinition and old-style casts (#2569 <https://github.com/ros-controls/ros2_control/issues/2569>)
  * [Spawner] Release the lock while waiting for the interrupt (#2559 <https://github.com/ros-controls/ros2_control/issues/2559>)
  * Fix the reloading controller with failed activation (#2544 <https://github.com/ros-controls/ros2_control/issues/2544>)
  * Don't print the overrun warnings for the simulations (#2539 <https://github.com/ros-controls/ros2_control/issues/2539>)
  * Readd the ResourceManagerParams initialization to ControllerManager (#2522 <https://github.com/ros-controls/ros2_control/issues/2522>)
  * Publish controller manager statistics to better introspect the timings (#2449 <https://github.com/ros-controls/ros2_control/issues/2449>)
  * Fix the CPU affinity of the ros2_control_node (#2509 <https://github.com/ros-controls/ros2_control/issues/2509>)
  * Contributors: Christoph Fröhlich, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 03 Oct 2025 00:00:00 -0000

ros-kilted-controller-manager (5.6.0-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 26 Aug 2025 00:00:00 -0000

ros-kilted-controller-manager (5.5.0-1noble) noble; urgency=high

  * Fix the prepare_command_mode_switch behaviour when HW is INACTIVE (#2347 <https://github.com/ros-controls/ros2_control/issues/2347>)
  * Contributors: Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 31 Jul 2025 00:00:00 -0000

ros-kilted-controller-manager (5.4.0-1noble) noble; urgency=high

  * Increase controller period tolerance further (#2405 <https://github.com/ros-controls/ros2_control/issues/2405>)
  * Fix controller activation crash on macOS (Fixes #604 <https://github.com/ros-controls/ros2_control/issues/604>) (#2391 <https://github.com/ros-controls/ros2_control/issues/2391>)
  * Increase controller period tolerance in tests (#2388 <https://github.com/ros-controls/ros2_control/issues/2388>)
  * [spawner] Fix Lock timeout error crashes (#2386 <https://github.com/ros-controls/ros2_control/issues/2386>)
  * [Spawner] Fix the scope issue of the logger (#2382 <https://github.com/ros-controls/ros2_control/issues/2382>)
  * Increase tolerance to improve the success rate of the tests (#2373 <https://github.com/ros-controls/ros2_control/issues/2373>)
  * [Spawner] Change strategy for --unload-on-kill option (#2372 <https://github.com/ros-controls/ros2_control/issues/2372>)
  * Contributors: Dhruv Patel, Jasper van Brakel, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 21 Jul 2025 00:00:00 -0000

ros-kilted-controller-manager (5.3.0-1noble) noble; urgency=high

  * Cleanup old internal API (#2346 <https://github.com/ros-controls/ros2_control/issues/2346>)
  * added params approach to allow propagation in gz_ros2_control (#2340 <https://github.com/ros-controls/ros2_control/issues/2340>)
  * Deactivate controllers with command interfaces to hardware on DEACTIVATE (#2334 <https://github.com/ros-controls/ros2_control/issues/2334>)
  * Shift to Struct based Method and Constructors, with Executor passed from CM to on_init() (#2323 <https://github.com/ros-controls/ros2_control/issues/2323>)
  * Contributors: Marq Rasmussen, Sai Kishor Kothakota, Soham Patil

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 02 Jul 2025 00:00:00 -0000

ros-kilted-controller-manager (5.2.0-1noble) noble; urgency=high

  * Move enforce_command_limits parameter to GPL parameters (#2305 <https://github.com/ros-controls/ros2_control/issues/2305>)
  * Cleanup test name (#2295 <https://github.com/ros-controls/ros2_control/issues/2295>)
  * check_controllers_running: Make timeout a parameter  (#2278 <https://github.com/ros-controls/ros2_control/issues/2278>)
  * Contributors: Christoph Fröhlich, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 07 Jun 2025 00:00:00 -0000

ros-kilted-controller-manager (5.1.0-1noble) noble; urgency=high

  * Use target_link_libraries instead of ament_target_dependencies (#2266 <https://github.com/ros-controls/ros2_control/issues/2266>)
  * Cleanup deprecations in ros_control  (#2258 <https://github.com/ros-controls/ros2_control/issues/2258>)
  * Contributors: Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 24 May 2025 00:00:00 -0000

ros-kilted-controller-manager (5.0.0-1noble) noble; urgency=high

  * [CM] Add option to avoid shutting down on hardware initial state failure (#2230 <https://github.com/ros-controls/ros2_control/issues/2230>)
  * Statically allocate string concatenations using FMT formatting (#2205 <https://github.com/ros-controls/ros2_control/issues/2205>)
  * Suppress the deprecation warnings of the hardware_interface API (#2223 <https://github.com/ros-controls/ros2_control/issues/2223>)
  * Use warning attribute of RcutilsLogger (#2244 <https://github.com/ros-controls/ros2_control/issues/2244>)
  * [CM] Set default strictness of switch_controllers using parameters (#2168 <https://github.com/ros-controls/ros2_control/issues/2168>)
  * Add data_type field to the HardwareInterfaces message (#2204 <https://github.com/ros-controls/ros2_control/issues/2204>)
  * Add new strictness modes to SwitchController service (#2224 <https://github.com/ros-controls/ros2_control/issues/2224>)
  * Contributors: Marq Rasmussen, Sai Kishor Kothakota, mini-1235

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 21 May 2025 00:00:00 -0000

ros-kilted-controller-manager (4.29.0-1noble) noble; urgency=high

  * Use the new reusable helpers methods in hardware diagnostics (#2216 <https://github.com/ros-controls/ros2_control/issues/2216>)
  * [Diagnostics] Add diagnostics of execution time and periodicity of the hardware components (#2086 <https://github.com/ros-controls/ros2_control/issues/2086>)
  * Add common reusable helper methods header (#2099 <https://github.com/ros-controls/ros2_control/issues/2099>)
  * Use filelock in spawner to avoid concurrent operations (#2202 <https://github.com/ros-controls/ros2_control/issues/2202>)
  * increase test tolerance to reduce flakiness (#2212 <https://github.com/ros-controls/ros2_control/issues/2212>)
  * Add a method to perform the hardware command mode changes (#2203 <https://github.com/ros-controls/ros2_control/issues/2203>)
  * Fix typos: preceeding -> preceding (#2206 <https://github.com/ros-controls/ros2_control/issues/2206>)
  * Throttle the overrun logs (#2201 <https://github.com/ros-controls/ros2_control/issues/2201>)
  * doc: Added explanation of preceding/following controllers (#2192 <https://github.com/ros-controls/ros2_control/issues/2192>)
  * Contributors: Christoph Fröhlich, Martin Pecka, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 04 May 2025 00:00:00 -0000

ros-kilted-controller-manager (4.28.1-1noble) noble; urgency=high

  * Fix the enforce_command_limits deactivation (#2181 <https://github.com/ros-controls/ros2_control/issues/2181>)
  * Contributors: Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 17 Apr 2025 00:00:00 -0000

ros-kilted-controller-manager (4.28.0-1noble) noble; urgency=high

  * Integrate joint limit enforcement into ros2_control framework functional with Async controllers and components  (#2047 <https://github.com/ros-controls/ros2_control/issues/2047>)
  * Make all packages use gmock, not gtest (#2162 <https://github.com/ros-controls/ros2_control/issues/2162>)
  * Fix async controllers deactivation regime (#2017 <https://github.com/ros-controls/ros2_control/issues/2017>)
  * apply pre-commit changes (#2160 <https://github.com/ros-controls/ros2_control/issues/2160>)
  * Add tests for multiple controller ros args (#2155 <https://github.com/ros-controls/ros2_control/issues/2155>)
  * Bump version of pre-commit hooks (#2156 <https://github.com/ros-controls/ros2_control/issues/2156>)
  * Allow for multiple controller-ros-args arguments in spawner.py (#2150 <https://github.com/ros-controls/ros2_control/issues/2150>)
  * Update rqt_controller_manager controller state color scheme to match list_controllers color scheme (#2143 <https://github.com/ros-controls/ros2_control/issues/2143>)
  * Fix generate_controllers_spawner_launch_description_from_dict (#2146 <https://github.com/ros-controls/ros2_control/issues/2146>)
  * Use ros2_control_cmake (#2134 <https://github.com/ros-controls/ros2_control/issues/2134>)
  * [Docs] Update determinism section (#2131 <https://github.com/ros-controls/ros2_control/issues/2131>)
  * Remove the dangling param flag for robot_description fom ROS parameters (#2115 <https://github.com/ros-controls/ros2_control/issues/2115>)
  * [Doc] Add documentation of different controller manager clocks (#2109 <https://github.com/ros-controls/ros2_control/issues/2109>)
  * [CM] Extend the list controller and hardware components messages (#2102 <https://github.com/ros-controls/ros2_control/issues/2102>)
  * Improve package descriptions & update maintainers (#2103 <https://github.com/ros-controls/ros2_control/issues/2103>)
  * Reject duplicate state/command interfaces after configuring the controller  (#2090 <https://github.com/ros-controls/ros2_control/issues/2090>)
  * [CM] Add message field to the switch_controller service (#2088 <https://github.com/ros-controls/ros2_control/issues/2088>)
  * Update doc: async update support for controller (#2096 <https://github.com/ros-controls/ros2_control/issues/2096>)
  * Use monotonic clock for triggering read-update-write cycles + fix for overruns (#2046 <https://github.com/ros-controls/ros2_control/issues/2046>)
  * Add some logging for unload_on_kill keyboard interrupt (#2097 <https://github.com/ros-controls/ros2_control/issues/2097>)
  * [CM] Add controller_manager activity topic (#2006 <https://github.com/ros-controls/ros2_control/issues/2006>)
  * Improve diagnostics strings (#2078 <https://github.com/ros-controls/ros2_control/issues/2078>)
  * Contributors: Bence Magyar, Christoph Fröhlich, Julia Jia, Sai Kishor Kothakota, Soham Patil, danielcostanzi18, github-actions[bot]

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 10 Apr 2025 00:00:00 -0000

ros-kilted-controller-manager (4.27.0-1noble) noble; urgency=high

  * [HW Components] Add fix for async hardware components improper rate (#2076 <https://github.com/ros-controls/ros2_control/issues/2076>)
  * [CM] Skip robot_description topic remapping for controllers (#2082 <https://github.com/ros-controls/ros2_control/issues/2082>)
  * [Spawner] Fix case with wildcard AND explicit controller in the same file (#2080 <https://github.com/ros-controls/ros2_control/issues/2080>)
  * [Handle] Use get_optional instead of get_value<double> (#2061 <https://github.com/ros-controls/ros2_control/issues/2061>)
  * [CM] Fix switch_controller behaviour with unknown controller switch request (#2060 <https://github.com/ros-controls/ros2_control/issues/2060>)
  * Cleanup chainable controller exported interfaces to allow reconfiguring  (#2073 <https://github.com/ros-controls/ros2_control/issues/2073>)
  * Update memlock values in doc (#2066 <https://github.com/ros-controls/ros2_control/issues/2066>)
  * Add new get_value API for Handles and Interfaces (#1976 <https://github.com/ros-controls/ros2_control/issues/1976>)
  * Fix unused timeouts in load/unload controller (#2052 <https://github.com/ros-controls/ros2_control/issues/2052>)
  * [CM] Improve memory allocation with buffer variables (#1801 <https://github.com/ros-controls/ros2_control/issues/1801>)
  * Integrate pal_statistics for introspection of controllers, hardware components and more (#1918 <https://github.com/ros-controls/ros2_control/issues/1918>)
  * [CM] Fix the controller deactivation on the control cycles returning ERROR  (#1756 <https://github.com/ros-controls/ros2_control/issues/1756>)
  * Contributors: Christoph Fröhlich, Dawid Kmak, Sai Kishor Kothakota, bijoua29

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 01 Mar 2025 00:00:00 -0000

ros-kilted-controller-manager (4.26.0-1noble) noble; urgency=high

  * Slightly increase timeout of test_spawner_unspawner (#2037 <https://github.com/ros-controls/ros2_control/issues/2037>)
  * Contributors: Christoph Fröhlich

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 07 Feb 2025 00:00:00 -0000

ros-kilted-controller-manager (4.25.0-1noble) noble; urgency=high

  * Handle SIGINT properly in the controller manager (#2014 <https://github.com/ros-controls/ros2_control/issues/2014>)
  * Fix the initial wrong periodicity reported by controller_manager (#2018 <https://github.com/ros-controls/ros2_control/issues/2018>)
  * Use target_compile_definitions instead of installing test files (#2009 <https://github.com/ros-controls/ros2_control/issues/2009>)
  * Fix a heading level (#2007 <https://github.com/ros-controls/ros2_control/issues/2007>)
  * Update path of GPL (#1994 <https://github.com/ros-controls/ros2_control/issues/1994>)
  * Fix: on_shutdown callback of controllers never get executed (#1995 <https://github.com/ros-controls/ros2_control/issues/1995>)
  * Contributors: Christoph Fröhlich, Sai Kishor Kothakota, Wiktor Bajor

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 29 Jan 2025 00:00:00 -0000

ros-kilted-controller-manager (4.24.0-1noble) noble; urgency=high

  * [CM] Remove obsolete ControllerMock from the tests (#1990 <https://github.com/ros-controls/ros2_control/issues/1990>)
  * Initialize robot description in ControllerManager (#1983 <https://github.com/ros-controls/ros2_control/issues/1983>)
  * Contributors: Dominic Reber, Wiktor Bajor

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 13 Jan 2025 00:00:00 -0000

ros-kilted-controller-manager (4.23.0-1noble) noble; urgency=high

  * Remove boilerplate visibility macros (#1972 <https://github.com/ros-controls/ros2_control/issues/1972>)
  * Move test_utils module from demos repo (#1955 <https://github.com/ros-controls/ros2_control/issues/1955>)
  * Fix deprecated usage of lock_memory API (#1970 <https://github.com/ros-controls/ros2_control/issues/1970>)
  * Fix spawner behaviour on failing controller activation or deactivation (#1941 <https://github.com/ros-controls/ros2_control/issues/1941>)
  * Contributors: Bence Magyar, Christoph Fröhlich, Sai Kishor Kothakota, Sudip Roy

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 29 Dec 2024 00:00:00 -0000

ros-kilted-controller-manager (4.22.0-1noble) noble; urgency=high

  * Async Hardware Components (#1567 <https://github.com/ros-controls/ros2_control/issues/1567>)
  * Add controller node options args to be able to set controller specific node arguments (#1713 <https://github.com/ros-controls/ros2_control/issues/1713>)
  * Use singleton approach to store and reuse the service clients (#1949 <https://github.com/ros-controls/ros2_control/issues/1949>)
  * Increase the max and min periodicity tolerances to fix flaky tests (#1937 <https://github.com/ros-controls/ros2_control/issues/1937>)
  * Fix the spawner to support full wildcard parameter entries (#1933 <https://github.com/ros-controls/ros2_control/issues/1933>)
  * Suppress unnecessary warnings in clock received validation (#1935 <https://github.com/ros-controls/ros2_control/issues/1935>)
  * Optimize the valid time check in the update loop (#1923 <https://github.com/ros-controls/ros2_control/issues/1923>)
  * [CI] Add clang job, setup concurrency, use rt_tools humble branch (#1910 <https://github.com/ros-controls/ros2_control/issues/1910>)
  * Update CPU affinity parameter to be able to set multiple CPUs (#1915 <https://github.com/ros-controls/ros2_control/issues/1915>)
  * Contributors: Christoph Fröhlich, Sai Kishor Kothakota, Takashi Sato

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 20 Dec 2024 00:00:00 -0000

ros-kilted-controller-manager (4.21.0-1noble) noble; urgency=high

  * Use the .hpp headers from realtime_tools package (#1916 <https://github.com/ros-controls/ros2_control/issues/1916>)
  * CM: Check if a valid time is received (#1901 <https://github.com/ros-controls/ros2_control/issues/1901>)
  * Lock memory by default on a realtime system setup (#1896 <https://github.com/ros-controls/ros2_control/issues/1896>)
  * Fix the launch_utils regression (#1909 <https://github.com/ros-controls/ros2_control/issues/1909>)
  * [Diagnostics] Add diagnostics of execution time and periodicity of the controllers and controller_manager (#1871 <https://github.com/ros-controls/ros2_control/issues/1871>)
  * Add more parameter overriding tests by parsing multiple parameter files (#1899 <https://github.com/ros-controls/ros2_control/issues/1899>)
  * add logic for 'params_file' to handle both string and string_array (#1898 <https://github.com/ros-controls/ros2_control/issues/1898>)
  * [Spawner] Accept parsing multiple --param-file arguments to spawner  (#1805 <https://github.com/ros-controls/ros2_control/issues/1805>)
  * Add documentation on ros2_control_node and make lock_memory false by default (#1890 <https://github.com/ros-controls/ros2_control/issues/1890>)
  * Add service call timeout argument in spawner (#1808 <https://github.com/ros-controls/ros2_control/issues/1808>)
  * Add CM switch_controller service timeout as parameter to spawner.py (#1790 <https://github.com/ros-controls/ros2_control/issues/1790>)
  * Fix the missing bcolors.ENDC in hardware_spawner log prints (#1870 <https://github.com/ros-controls/ros2_control/issues/1870>)
  * Contributors: Christoph Fröhlich, Sai Kishor Kothakota, Tony Najjar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 06 Dec 2024 00:00:00 -0000

ros-kilted-controller-manager (4.20.0-1noble) noble; urgency=high

  * change from thread_priority.hpp to realtime_helpers.hpp (#1829 <https://github.com/ros-controls/ros2_control/issues/1829>)
  * Use Clock instead of Rate for backward compatibility of rolling (#1864 <https://github.com/ros-controls/ros2_control/issues/1864>)
  * [ros2_control_node] Handle simulation environment clocks (#1810 <https://github.com/ros-controls/ros2_control/issues/1810>)
  * [CM] Fix controller missing update cycles in a real setup (#1774 <https://github.com/ros-controls/ros2_control/issues/1774>)
  * [ros2_control_node] Add option to set the CPU affinity  (#1852 <https://github.com/ros-controls/ros2_control/issues/1852>)
  * [ros2_control_node] Add the realtime_tools lock_memory method to prevent page faults (#1822 <https://github.com/ros-controls/ros2_control/issues/1822>)
  * Fix CMP0115 (#1830 <https://github.com/ros-controls/ros2_control/issues/1830>)
  * fix: typo use thread_priority (#1844 <https://github.com/ros-controls/ros2_control/issues/1844>)
  * Fix Hardware spawner and add tests for it (#1759 <https://github.com/ros-controls/ros2_control/issues/1759>)
  * add thread_priority option to the ros2_control_node (#1820 <https://github.com/ros-controls/ros2_control/issues/1820>)
  * Contributors: Baris Yazici, Christoph Fröhlich, Felix Exner (fexner), Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 08 Nov 2024 00:00:00 -0000

ros-kilted-controller-manager (4.19.0-1noble) noble; urgency=high

  * Fix timeout value in std output (#1807 <https://github.com/ros-controls/ros2_control/issues/1807>)
  * [CM] Async Function Handler for Controllers (#1489 <https://github.com/ros-controls/ros2_control/issues/1489>)
  * [Spawner] Add support for wildcard entries in the controller param files  (#1724 <https://github.com/ros-controls/ros2_control/issues/1724>)
  * [Feature] Fallback controllers (#1789 <https://github.com/ros-controls/ros2_control/issues/1789>)
  * Check the update_rate set to the controllers to be a valid one (#1788 <https://github.com/ros-controls/ros2_control/issues/1788>)
  * [PR-1689] Follow-up PR of the controller interface variants integration (#1779 <https://github.com/ros-controls/ros2_control/issues/1779>)
  * Improve diagnostics of Controllers, Hardware Components and Controller Manager (#1764 <https://github.com/ros-controls/ros2_control/issues/1764>)
  * Improve launch utils to support the multiple controller names (#1782 <https://github.com/ros-controls/ros2_control/issues/1782>)
  * [RM/HW] Constify the exported state interfaces using ConstSharedPtr (#1767 <https://github.com/ros-controls/ros2_control/issues/1767>)
  * [CM] Throw an exception when the components initially fail to be in the required state (#1729 <https://github.com/ros-controls/ros2_control/issues/1729>)
  * Contributors: Felix Exner (fexner), Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 26 Oct 2024 00:00:00 -0000

ros-kilted-controller-manager (4.18.0-1noble) noble; urgency=high

  * Adapt controller Reference/StateInterfaces to New Way of Exporting (variant support) (#1689 <https://github.com/ros-controls/ros2_control/issues/1689>)
  * Add test coverage for params_file parameter in spawner/unspawner tests (#1754 <https://github.com/ros-controls/ros2_control/issues/1754>)
  * [ros2controlcli] add params file parsing to load_controller verb and add namespacing support  (#1703 <https://github.com/ros-controls/ros2_control/issues/1703>)
  * Contributors: Manuel Muth, Sai Kishor Kothakota, Santosh Govindaraj

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 07 Oct 2024 00:00:00 -0000

ros-kilted-controller-manager (4.17.0-1noble) noble; urgency=high

  * Log exception type when catching the exception (#1749 <https://github.com/ros-controls/ros2_control/issues/1749>)
  * [CM] Handle other exceptions while loading the controller plugin (#1731 <https://github.com/ros-controls/ros2_control/issues/1731>)
  * remove unnecessary log of the CM args (#1720 <https://github.com/ros-controls/ros2_control/issues/1720>)
  * Fix unload of controllers when spawned with --unload-on-kill (#1717 <https://github.com/ros-controls/ros2_control/issues/1717>)
  * Rename get_state and set_state Functions to get/set_lifecylce_state (variant support) (#1683 <https://github.com/ros-controls/ros2_control/issues/1683>)
  * Contributors: Manuel Muth, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 11 Sep 2024 00:00:00 -0000

ros-kilted-controller-manager (4.16.1-1noble) noble; urgency=high

  * propage a portion of global args to the controller nodes (#1712 <https://github.com/ros-controls/ros2_control/issues/1712>)
  * Contributors: Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 24 Aug 2024 00:00:00 -0000

ros-kilted-controller-manager (4.16.0-1noble) noble; urgency=high

  * inform user what reason is for not setting rt policy, inform is policy (#1705 <https://github.com/ros-controls/ros2_control/issues/1705>)
  * Fix params_file typo in spawner and update release notes for use_global_arguments (#1701 <https://github.com/ros-controls/ros2_control/issues/1701>)
  * Fix spawner tests timeout (#1692 <https://github.com/ros-controls/ros2_control/issues/1692>)
  * Refactor spawner to be able to reuse code for ros2controlcli (#1661 <https://github.com/ros-controls/ros2_control/issues/1661>)
  * Robustify controller spawner and add integration test with many controllers (#1501 <https://github.com/ros-controls/ros2_control/issues/1501>)
  * Handle waiting in Spawner and align Hardware Spawner functionality (#1562 <https://github.com/ros-controls/ros2_control/issues/1562>)
  * Make list controller and list hardware components immediately visualize the state. (#1606 <https://github.com/ros-controls/ros2_control/issues/1606>)
  * [CI] Add coveragepy and remove ignore: test (#1668 <https://github.com/ros-controls/ros2_control/issues/1668>)
  * Fix spawner unload on kill test (#1675 <https://github.com/ros-controls/ros2_control/issues/1675>)
  * [CM] Add more logging for easier debugging (#1645 <https://github.com/ros-controls/ros2_control/issues/1645>)
  * refactor SwitchParams to fix the incosistencies in the spawner tests (#1638 <https://github.com/ros-controls/ros2_control/issues/1638>)
  * Contributors: Bence Magyar, Christoph Fröhlich, Dr. Denis, Felix Exner (fexner), Manuel Muth, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 22 Aug 2024 00:00:00 -0000

ros-kilted-controller-manager (4.15.0-1noble) noble; urgency=high

  * Add missing include for executors (#1653 <https://github.com/ros-controls/ros2_control/issues/1653>)
  * Fix the namespaced controller_manager spawner + added tests (#1640 <https://github.com/ros-controls/ros2_control/issues/1640>)
  * CM: Add missing includes (#1641 <https://github.com/ros-controls/ros2_control/issues/1641>)
  * Fix rst markup (#1642 <https://github.com/ros-controls/ros2_control/issues/1642>)
  * Add a pytest launch file to test ros2_control_node (#1636 <https://github.com/ros-controls/ros2_control/issues/1636>)
  * [CM] Remove deprecated spawner args (#1639 <https://github.com/ros-controls/ros2_control/issues/1639>)
  * Contributors: Christoph Fröhlich, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 05 Aug 2024 00:00:00 -0000

ros-kilted-controller-manager (4.14.0-1noble) noble; urgency=high

  * Unused header cleanup (#1627 <https://github.com/ros-controls/ros2_control/issues/1627>)
  * Remove noqa (#1626 <https://github.com/ros-controls/ros2_control/issues/1626>)
  * Fix controller starting with later load of robot description test (#1624 <https://github.com/ros-controls/ros2_control/issues/1624>)
  * [CM] Remove support for the description parameter and use only robot_description topic (#1358 <https://github.com/ros-controls/ros2_control/issues/1358>)
  * Contributors: Christoph Fröhlich, Dr. Denis, Henry Moore, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 23 Jul 2024 00:00:00 -0000

ros-kilted-controller-manager (4.13.0-1noble) noble; urgency=high

  * Change the spamming checking interface ERROR to DEBUG (#1605 <https://github.com/ros-controls/ros2_control/issues/1605>)
  * [ResourceManager] Propagate access to logger and clock interfaces to HardwareComponent (#1585 <https://github.com/ros-controls/ros2_control/issues/1585>)
  * [ControllerChaining] Export state interfaces from chainable controllers (#1021 <https://github.com/ros-controls/ros2_control/issues/1021>)
  * Contributors: Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 08 Jul 2024 00:00:00 -0000

ros-kilted-controller-manager (4.12.0-1noble) noble; urgency=high

  * [rqt_controller_manager] Add hardware components (#1455 <https://github.com/ros-controls/ros2_control/issues/1455>)
  * [RM] Rename load_urdf method to load_and_initialize_components and add error handling there to avoid stack crashing when error happens. (#1354 <https://github.com/ros-controls/ros2_control/issues/1354>)
  * Fix update period for the first update after activation (#1551 <https://github.com/ros-controls/ros2_control/issues/1551>)
  * Bump version of pre-commit hooks (#1556 <https://github.com/ros-controls/ros2_control/issues/1556>)
  * Contributors: Christoph Fröhlich, Dr. Denis, github-actions[bot]

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 01 Jul 2024 00:00:00 -0000

ros-kilted-controller-manager (4.11.0-1noble) noble; urgency=high

  * Add find_package for ament_cmake_gen_version_h (#1534 <https://github.com/ros-controls/ros2_control/issues/1534>)
  * Contributors: Christoph Fröhlich

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 14 May 2024 00:00:00 -0000

ros-kilted-controller-manager (4.10.0-1noble) noble; urgency=high

  * allow extra spawner arguments to not declare every argument in launch utils (#1505 <https://github.com/ros-controls/ros2_control/issues/1505>)
  * Working async controllers and components [not synchronized] (#1041 <https://github.com/ros-controls/ros2_control/issues/1041>)
  * Add fallback controllers list to the ControllerInfo (#1503 <https://github.com/ros-controls/ros2_control/issues/1503>)
  * Add a functionality to look for the controller type in the params file when not parsed (#1502 <https://github.com/ros-controls/ros2_control/issues/1502>)
  * Add controller exception handling in controller manager (#1507 <https://github.com/ros-controls/ros2_control/issues/1507>)
  * Contributors: Márk Szitanics, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 08 May 2024 00:00:00 -0000

ros-kilted-controller-manager (4.9.0-1noble) noble; urgency=high

  * Deactivate the controllers when they return error similar to hardware (#1499 <https://github.com/ros-controls/ros2_control/issues/1499>)
  * Component parser: Get mimic information from URDF (#1256 <https://github.com/ros-controls/ros2_control/issues/1256>)
  * Contributors: Christoph Fröhlich, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 30 Apr 2024 00:00:00 -0000

ros-kilted-controller-manager (4.8.0-1noble) noble; urgency=high

  * generate version.h file per package using the ament_generate_version_header  (#1449 <https://github.com/ros-controls/ros2_control/issues/1449>)
  * Use ament_cmake generated rclcpp version header (#1448 <https://github.com/ros-controls/ros2_control/issues/1448>)
  * Replace random_shuffle with shuffle. (#1446 <https://github.com/ros-controls/ros2_control/issues/1446>)
  * Contributors: Chris Lalancette, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 27 Mar 2024 00:00:00 -0000

ros-kilted-controller-manager (4.7.0-1noble) noble; urgency=high

  * add missing compiler definitions of RCLCPP_VERSION_MAJOR (#1440 <https://github.com/ros-controls/ros2_control/issues/1440>)
  * Codeformat from new pre-commit config (#1433 <https://github.com/ros-controls/ros2_control/issues/1433>)
  * add conditioning to get_parameter_value method import (#1428 <https://github.com/ros-controls/ros2_control/issues/1428>)
  * Change the controller sorting with an approach similar to directed acyclic graphs (#1384 <https://github.com/ros-controls/ros2_control/issues/1384>)
  * Contributors: Christoph Fröhlich, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 22 Mar 2024 00:00:00 -0000

ros-kilted-controller-manager (4.6.0-1noble) noble; urgency=high

  * Add -Werror=missing-braces to compile options (#1423 <https://github.com/ros-controls/ros2_control/issues/1423>)
  * added conditioning to have rolling tags compilable in older versions (#1422 <https://github.com/ros-controls/ros2_control/issues/1422>)
  * [CM] Remove deprecated parameters for initial component states. (#1357 <https://github.com/ros-controls/ros2_control/issues/1357>)
  * [BREAKING CHANGE] Use robot_description topic instead of ~/robot_description and update docs regarding this (#1410 <https://github.com/ros-controls/ros2_control/issues/1410>)
  * [CI] Code coverage + pre-commit (#1413 <https://github.com/ros-controls/ros2_control/issues/1413>)
  * Fix multiple chainable controller activation bug (#1401 <https://github.com/ros-controls/ros2_control/issues/1401>)
  * Contributors: Christoph Fröhlich, Dr. Denis, Felix Exner (fexner), Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 02 Mar 2024 00:00:00 -0000

ros-kilted-controller-manager (4.5.0-1noble) noble; urgency=high

  * check for state of the controller node before cleanup (#1363 <https://github.com/ros-controls/ros2_control/issues/1363>)
  * [CM] Use explicit constants in controller tests. (#1356 <https://github.com/ros-controls/ros2_control/issues/1356>)
  * [CM] Optimized debug output about interfaces when switching controllers. (#1355 <https://github.com/ros-controls/ros2_control/issues/1355>)
  * A method to get node options to setup the controller node #api-breaking (#1169 <https://github.com/ros-controls/ros2_control/issues/1169>)
  * Contributors: Dr. Denis, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 12 Feb 2024 00:00:00 -0000

ros-kilted-controller-manager (4.4.0-1noble) noble; urgency=high

  * Move test_components to own package (#1325 <https://github.com/ros-controls/ros2_control/issues/1325>)
  * Fix controller parameter loading issue in different cases (#1293 <https://github.com/ros-controls/ros2_control/issues/1293>)
  * Contributors: Christoph Fröhlich, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 31 Jan 2024 00:00:00 -0000

ros-kilted-controller-manager (4.3.0-1noble) noble; urgency=high

  * [CM] Better readability and maintainability: rename variables, move code to more logical places 🔧 (#1227 <https://github.com/ros-controls/ros2_control/issues/1227>)
  * Initialize the controller manager services after initializing resource manager (#1271 <https://github.com/ros-controls/ros2_control/issues/1271>)
  * Issue 695: Changing 'namespace_' variables to 'node_namespace' to make it more explicit (#1239 <https://github.com/ros-controls/ros2_control/issues/1239>)
  * Fix rqt controller manager crash on ros2_control restart (#1273 <https://github.com/ros-controls/ros2_control/issues/1273>)
  * [docs] Remove joint_state_controller (#1263 <https://github.com/ros-controls/ros2_control/issues/1263>)
  * controller_manager: Add space to string literal concatenation (#1245 <https://github.com/ros-controls/ros2_control/issues/1245>)
  * Try using SCHED_FIFO on any kernel (#1142 <https://github.com/ros-controls/ros2_control/issues/1142>)
  * [CM] Set chained controller interfaces 'available' for activated controllers (#1098 <https://github.com/ros-controls/ros2_control/issues/1098>)
  * [CM] Increase tests timeout (#1224 <https://github.com/ros-controls/ros2_control/issues/1224>)
  * Contributors: Christoph Fröhlich, Dr. Denis, Felix Exner (fexner), Sai Kishor Kothakota, Yasushi SHOJI, bailaC

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 20 Jan 2024 00:00:00 -0000

ros-kilted-controller-manager (4.2.0-1noble) noble; urgency=high

  * [CM] Linting if/else statements (#1193 <https://github.com/ros-controls/ros2_control/issues/1193>)
  * Reformat with braces added (#1209 <https://github.com/ros-controls/ros2_control/issues/1209>)
  * Report inactive controllers as a diagnostics ok instead of an error (#1184 <https://github.com/ros-controls/ros2_control/issues/1184>)
  * Fix controller sorting issue while loading large number of controllers (#1180 <https://github.com/ros-controls/ros2_control/issues/1180>)
  * Contributors: Bence Magyar, Dr. Denis, Lennart Nachtigall, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 12 Dec 2023 00:00:00 -0000

ros-kilted-controller-manager (4.1.0-1noble) noble; urgency=high

  * Add few warning compiler options to error (#1181 <https://github.com/ros-controls/ros2_control/issues/1181>)
  * [ControllerManager] Fix all warnings from the latets features. (#1174 <https://github.com/ros-controls/ros2_control/issues/1174>)
  * Compute the actual update period for each controller (#1140 <https://github.com/ros-controls/ros2_control/issues/1140>)
  * Contributors: Dr. Denis, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 30 Nov 2023 00:00:00 -0000

ros-kilted-controller-manager (4.0.0-1noble) noble; urgency=high

  * Pass controller manager update rate on the init of the controller interface  (#1141 <https://github.com/ros-controls/ros2_control/issues/1141>)
  * Fix the controller sorting bug when the interfaces are not configured (fixes #1164 <https://github.com/ros-controls/ros2_control/issues/1164>) (#1165 <https://github.com/ros-controls/ros2_control/issues/1165>)
  * Pass URDF to controllers on init (#1088 <https://github.com/ros-controls/ros2_control/issues/1088>)
  * Remove deprecation warning (#1101 <https://github.com/ros-controls/ros2_control/issues/1101>)
  * Contributors: Bence Magyar, Christoph Fröhlich, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 21 Nov 2023 00:00:00 -0000

ros-kilted-controller-manager (3.21.0-1noble) noble; urgency=high

  * Sort controllers while configuring instead of while activating (#1107 <https://github.com/ros-controls/ros2_control/issues/1107>)
  * Contributors: Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 06 Nov 2023 00:00:00 -0000

ros-kilted-controller-manager (3.20.0-1noble) noble; urgency=high

  * Update spawner to accept controllers list and start them in sequence (#1139 <https://github.com/ros-controls/ros2_control/issues/1139>)
  * [ResourceManager] deactivate hardware from read/write return value (#884 <https://github.com/ros-controls/ros2_control/issues/884>)
  * Export of the get_cm_node_options() from robostack (#1129 <https://github.com/ros-controls/ros2_control/issues/1129>)
  * Contributors: Felix Exner (fexner), Olivier Stasse, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 31 Oct 2023 00:00:00 -0000

ros-kilted-controller-manager (3.19.1-1noble) noble; urgency=high

  * Fix next controller update cycle time clock (#1127 <https://github.com/ros-controls/ros2_control/issues/1127>)
  * Contributors: Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 04 Oct 2023 00:00:00 -0000

ros-kilted-controller-manager (3.19.0-1noble) noble; urgency=high

  * Proper controller update rate (#1105 <https://github.com/ros-controls/ros2_control/issues/1105>)
  * Fix multiple calls to export reference interfaces (#1108 <https://github.com/ros-controls/ros2_control/issues/1108>)
  * [Docs] Fix information about activation and deactivation of chainable controllers (#1104 <https://github.com/ros-controls/ros2_control/issues/1104>)
  * Contributors: Dr. Denis, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 03 Oct 2023 00:00:00 -0000

ros-kilted-controller-manager (3.18.0-1noble) noble; urgency=high

  * Controller sorting and proper execution in a chain (Fixes #853 <https://github.com/ros-controls/ros2_control/issues/853>) (#1063 <https://github.com/ros-controls/ros2_control/issues/1063>)
  * Contributors: Sai Kishor Kothakota, Christoph Fröhlich, Dr Denis, Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 17 Aug 2023 00:00:00 -0000

ros-kilted-controller-manager (3.17.0-1noble) noble; urgency=high

  * [CM] Fixes the issue with individual controller's update rate (#1082 <https://github.com/ros-controls/ros2_control/issues/1082>)
  * Fix deprecation warning (#1093 <https://github.com/ros-controls/ros2_control/issues/1093>)
  * Contributors: Christoph Fröhlich, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 07 Aug 2023 00:00:00 -0000

ros-kilted-controller-manager (3.16.0-1noble) noble; urgency=high

  * added controller manager runner to have update cycles (#1075 <https://github.com/ros-controls/ros2_control/issues/1075>)
  * [CM] Make error message after trying to active controller more informative. (#1066 <https://github.com/ros-controls/ros2_control/issues/1066>)
  * Fix equal and higher controller update rate (#1070 <https://github.com/ros-controls/ros2_control/issues/1070>)
  * Create doc file for chained controllers (#985 <https://github.com/ros-controls/ros2_control/issues/985>)
  * Contributors: Dr. Denis, Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 09 Jul 2023 00:00:00 -0000

ros-kilted-controller-manager (3.15.0-1noble) noble; urgency=high

  * Enable setting of initial state in HW compoments (#1046 <https://github.com/ros-controls/ros2_control/issues/1046>)
  * [CM] Improve output when using robot description topic and give output about correct topic even remapped. (#1059 <https://github.com/ros-controls/ros2_control/issues/1059>)
  * Contributors: Dr. Denis

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 23 Jun 2023 00:00:00 -0000

ros-kilted-controller-manager (3.14.0-1noble) noble; urgency=high

  * Add -Wconversion flag to protect future developments (#1053 <https://github.com/ros-controls/ros2_control/issues/1053>)
  * [CM] Use robot_description topic instead of parameter and don't crash on empty URDF 🦿 (#940 <https://github.com/ros-controls/ros2_control/issues/940>)
  * enable ReflowComments to also use ColumnLimit on comments (#1037 <https://github.com/ros-controls/ros2_control/issues/1037>)
  * Docs: Use branch name substitution for all links (#1031 <https://github.com/ros-controls/ros2_control/issues/1031>)
  * Add text to assertions references (#1023 <https://github.com/ros-controls/ros2_control/issues/1023>)
  * Contributors: Christoph Fröhlich, Felix Exner (fexner), Manuel Muth, Sai Kishor Kothakota, gwalck

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 14 Jun 2023 00:00:00 -0000

ros-kilted-controller-manager (3.13.0-1noble) noble; urgency=high

  * Add class for thread management of async hw interfaces (#981 <https://github.com/ros-controls/ros2_control/issues/981>)
  * Fix GitHub link on control.ros.org (#1022 <https://github.com/ros-controls/ros2_control/issues/1022>)
  * Remove log-level argument from spawner script (#1013 <https://github.com/ros-controls/ros2_control/issues/1013>)
  * Contributors: Christoph Fröhlich, Márk Szitanics, Bijou Abraham

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 18 May 2023 00:00:00 -0000

ros-kilted-controller-manager (3.12.2-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 29 Apr 2023 00:00:00 -0000

ros-kilted-controller-manager (3.12.1-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 14 Apr 2023 00:00:00 -0000

ros-kilted-controller-manager (3.12.0-1noble) noble; urgency=high

  * [Controller Interface] Add time and period paramters to update_reference_from_subscribers() (#846 <https://github.com/ros-controls/ros2_control/issues/846>) #API-break
  * Contributors: Robotgir

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 02 Apr 2023 00:00:00 -0000

ros-kilted-controller-manager (3.11.0-1noble) noble; urgency=high

  * [ControllerManager] Add Class for Async Controllers and Lifecycle Management (#932 <https://github.com/ros-controls/ros2_control/issues/932>)
  * Consistent use of colors for warning and error msgs in spawner (#974 <https://github.com/ros-controls/ros2_control/issues/974>)
  * Fix wrong warning messages (#973 <https://github.com/ros-controls/ros2_control/issues/973>)
  * Add log level support to spawner node (#972 <https://github.com/ros-controls/ros2_control/issues/972>)
  * Contributors: Dr. Denis, Márk Szitanics, Bijou Abraham

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 22 Mar 2023 00:00:00 -0000

ros-kilted-controller-manager (3.10.0-1noble) noble; urgency=high

  * add spawner for hardware (#941 <https://github.com/ros-controls/ros2_control/issues/941>)
  * Contributors: Manuel Muth

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 16 Mar 2023 00:00:00 -0000

ros-kilted-controller-manager (3.9.1-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 09 Mar 2023 00:00:00 -0000

ros-kilted-controller-manager (3.9.0-1noble) noble; urgency=high

  * fix AttributeError: Parameter object attribute name is read-only (#957 <https://github.com/ros-controls/ros2_control/issues/957>)
  * Remove deprecations from CLI and controller_manager (#948 <https://github.com/ros-controls/ros2_control/issues/948>)
  * Expose node options to controller manager (#942 <https://github.com/ros-controls/ros2_control/issues/942>)
  * Contributors: Christoph Fröhlich, Noel Jiménez García, methylDragon

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 28 Feb 2023 00:00:00 -0000

ros-kilted-controller-manager (3.8.0-1noble) noble; urgency=high

  * Fix CMake install so overriding works (#926 <https://github.com/ros-controls/ros2_control/issues/926>)
  * 🖤 Add Black formatter for Python files. (#936 <https://github.com/ros-controls/ros2_control/issues/936>)
  * Add list_hardware_components CLI <https://github.com/ros-controls/ros2_control/issues/796>`_ - Adds list_hardware_components to CLI (#891 <https://github.com/ros-controls/ros2_control/issues/891>)
  * Contributors: Andy McEvoy, Dr. Denis, Tyler Weaver

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 10 Feb 2023 00:00:00 -0000

ros-kilted-controller-manager (3.7.0-1noble) noble; urgency=high

  * Do not use CLI calls but direct API for setting parameters. (#910 <https://github.com/ros-controls/ros2_control/issues/910>)
  * Optimize output of controller spawner (#909 <https://github.com/ros-controls/ros2_control/issues/909>)
  * ControllerManager: catch exception by reference (#906 <https://github.com/ros-controls/ros2_control/issues/906>)
  * Test fix: don't keep reference to the controller in the test when it should be destroyed in the controller manager (#883 <https://github.com/ros-controls/ros2_control/issues/883>)
  * Merge branch 'fix-update-rate' into humble (#874 <https://github.com/ros-controls/ros2_control/issues/874>)
  * Contributors: Christopher Wecht, Dr. Denis, Tony Najjar, sgmurray

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 24 Jan 2023 00:00:00 -0000

ros-kilted-controller-manager (3.6.0-1noble) noble; urgency=high

  * Fix QoS deprecation warnings (#879 <https://github.com/ros-controls/ros2_control/issues/879>)
  * Add backward_ros to controller_manager (#886 <https://github.com/ros-controls/ros2_control/issues/886>)
  * Contributors: Andy McEvoy, Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 12 Jan 2023 00:00:00 -0000

ros-kilted-controller-manager (3.5.1-1noble) noble; urgency=high

  * Prevent controller manager from crashing when controller's plugin has error during loading. (#881 <https://github.com/ros-controls/ros2_control/issues/881>)
  * Contributors: Denis Štogl

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 06 Jan 2023 00:00:00 -0000

ros-kilted-controller-manager (3.5.0-1noble) noble; urgency=high

  * Rename class type to plugin name #api-breaking #abi-breaking (#780 <https://github.com/ros-controls/ros2_control/issues/780>)
  * Namespace Loaded Controllers (#852 <https://github.com/ros-controls/ros2_control/issues/852>)
  * Contributors: Bence Magyar, sp-sophia-labs

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 06 Dec 2022 00:00:00 -0000

ros-kilted-controller-manager (3.4.0-1noble) noble; urgency=high

  * Use a thread priority library from realtime_tools (#794 <https://github.com/ros-controls/ros2_control/issues/794>)
  * [Doc] Correct type of update_rate parameter (#858 <https://github.com/ros-controls/ros2_control/issues/858>)
  * Contributors: Andy Zelenak, Denis Štogl, Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 27 Nov 2022 00:00:00 -0000

ros-kilted-controller-manager (3.3.0-1noble) noble; urgency=high

  * Adding activation/deactivation tests for chain controllers (#809 <https://github.com/ros-controls/ros2_control/issues/809>)
  * Fix const-ness in std::chrono::time_point construction and explicitly use std::chrono::nanoseconds as std::chrono::time_point template parameter to help compilation on macOS as its std::chrono::system_clock::time_point defaults to std::chrono::milliseconds for duration type (#848 <https://github.com/ros-controls/ros2_control/issues/848>)
  * [ControllerManager] Fix wrong initialization order and avoid compiler warnings (#836 <https://github.com/ros-controls/ros2_control/issues/836>)
  * Contributors: Adrian Zwiener, Bilal Gill, Felix Exner, light-tech

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 15 Nov 2022 00:00:00 -0000

ros-kilted-controller-manager (3.2.0-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 15 Oct 2022 00:00:00 -0000

ros-kilted-controller-manager (3.1.0-1noble) noble; urgency=high

  * Don't ask to export reference interface if controller not 'inactive' or 'active' (#824 <https://github.com/ros-controls/ros2_control/issues/824>)
  * Add diagnostics for controllers activity (#820 <https://github.com/ros-controls/ros2_control/issues/820>)
  * Search for controller manager in the same namespace as spawner (#810 <https://github.com/ros-controls/ros2_control/issues/810>)
  * Handle HW errors on read and write in CM by stopping controllers (#742 <https://github.com/ros-controls/ros2_control/issues/742>)
    Add code for deactivating controller when hardware gets an error on read and write.
    Fix misleading variable name in the tests.
    Remove all interface from available list for hardware when an error happens.
    Do some more variable renaming to the new nomenclature.
  * Contributors: Denis Štogl, Tony Najjar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 05 Oct 2022 00:00:00 -0000

ros-kilted-controller-manager (3.0.0-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 19 Sep 2022 00:00:00 -0000

ros-kilted-controller-manager (2.15.0-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 19 Sep 2022 00:00:00 -0000

ros-kilted-controller-manager (2.14.0-1noble) noble; urgency=high

  * Add doxygen comments (#777 <https://github.com/ros-controls/ros2_control/issues/777>)
  * Contributors: Bence Magyar, Denis Štogl

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 04 Sep 2022 00:00:00 -0000

ros-kilted-controller-manager (2.13.0-1noble) noble; urgency=high

  * Clang tidy: delete a redundant return (#790 <https://github.com/ros-controls/ros2_control/issues/790>)
  * Add chained controllers information in list controllers service #abi-braking (#758 <https://github.com/ros-controls/ros2_control/issues/758>)
    * add chained controllers in ros2controlcli
    * remove controller_group from service
    * added comments to ControllerState message
    * added comments to ChainedConnection message
  * spawner.py: Fix python logging on deprecation warning (#787 <https://github.com/ros-controls/ros2_control/issues/787>)
  * Add documentation for realtime permission (#781 <https://github.com/ros-controls/ros2_control/issues/781>)
  * Fix bug in spawner with getter for node's logger (#776 <https://github.com/ros-controls/ros2_control/issues/776>)
  * Contributors: Andy Zelenak, Felix Exner, Paul Gesel, Bijou Abraham

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 03 Aug 2022 00:00:00 -0000

ros-kilted-controller-manager (2.12.1-1noble) noble; urgency=high

  * Rename CM members from start/stop to activate/deactivate nomenclature. (#756 <https://github.com/ros-controls/ros2_control/issues/756>)
  * Fix spelling in comment (#769 <https://github.com/ros-controls/ros2_control/issues/769>)
  * Contributors: Denis Štogl, Tyler Weaver

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 14 Jul 2022 00:00:00 -0000

ros-kilted-controller-manager (2.12.0-1noble) noble; urgency=high

  * Deprecate and rename start and stop nomenclature toward user to activate and deactivate #ABI-breaking (#755 <https://github.com/ros-controls/ros2_control/issues/755>)
    * Rename fields and deprecate old nomenclature.
    * Add new defines to SwitchController.srv
    * Deprecated start/stop nomenclature in all CLI commands.
    * Deprecate 'start_asap' too as other fields.
  * [ros2_control_node] Automatically detect if RT kernel is used and opportunistically enable SCHED_FIFO (#748 <https://github.com/ros-controls/ros2_control/issues/748>)
  * Contributors: Denis Štogl, Tyler Weaver

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 09 Jul 2022 00:00:00 -0000

ros-kilted-controller-manager (2.11.0-1noble) noble; urgency=high

  * Remove hybrid services in controller manager. (#761 <https://github.com/ros-controls/ros2_control/issues/761>)
  * [Interfaces] Improved ```get_name()``` method of hardware interfaces #api-breaking (#737 <https://github.com/ros-controls/ros2_control/issues/737>)
  * Update maintainers of packages (#753 <https://github.com/ros-controls/ros2_control/issues/753>)
  * Fix test dependency for chainable test (#751 <https://github.com/ros-controls/ros2_control/issues/751>)
  * Remove ament autolint (#749 <https://github.com/ros-controls/ros2_control/issues/749>)
  * Full functionality of chainable controllers in controller manager (#667 <https://github.com/ros-controls/ros2_control/issues/667>)
    * auto-switching of chained mode in controllers
    * interface-matching approach for managing chaining controllers
  * Fixup spanwer and unspawner tests. It changes spawner a bit to handle interupts internally. (#745 <https://github.com/ros-controls/ros2_control/issues/745>)
  * Add missing field to initializer lists in tests (#746 <https://github.com/ros-controls/ros2_control/issues/746>)
  * Small but useful output update on controller manager. (#741 <https://github.com/ros-controls/ros2_control/issues/741>)
  * Fixed period passed to hardware components always 0 (#738 <https://github.com/ros-controls/ros2_control/issues/738>)
  * Contributors: Bence Magyar, Denis Štogl, Maciej Bednarczyk, Lucas Schulze

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 03 Jul 2022 00:00:00 -0000

ros-kilted-controller-manager (2.10.0-1noble) noble; urgency=high

  * Make RHEL CI happy! (#730 <https://github.com/ros-controls/ros2_control/issues/730>)
  * CMakeLists cleanup (#733 <https://github.com/ros-controls/ros2_control/issues/733>)
  * Update to clang format 12 (#731 <https://github.com/ros-controls/ros2_control/issues/731>)
  * Contributors: Andy Zelenak, Bence Magyar, Márk Szitanics

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 18 Jun 2022 00:00:00 -0000

ros-kilted-controller-manager (2.9.0-1noble) noble; urgency=high

  * Adding base class for chained controllers: ChainedControllersInterface (#663 <https://github.com/ros-controls/ros2_control/issues/663>)
    * Extending ControllerInterface with methods for chainable controllers.
    * Switching to chained_mode is only forbidden if controller is active.
    * Default implementation for 'on_set_chained_mode' method.
    * Use two internal methods instead of 'update' directly on chained controllers.
  * Add ControllerInterfaceBase class with methods for chainable controller (#717 <https://github.com/ros-controls/ros2_control/issues/717>)
  * Contributors: Denis Štogl

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 19 May 2022 00:00:00 -0000

ros-kilted-controller-manager (2.8.0-1noble) noble; urgency=high

  * Pass time and period to read() and write() (#715 <https://github.com/ros-controls/ros2_control/issues/715>)
  * Contributors: Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 13 May 2022 00:00:00 -0000

ros-kilted-controller-manager (2.7.0-1noble) noble; urgency=high

  * Update ControllerManager documenation describing some concepts (#677 <https://github.com/ros-controls/ros2_control/issues/677>)
  * Make node private in ControllerInterface (#699 <https://github.com/ros-controls/ros2_control/issues/699>)
  * Contributors: Chen Bainian, Denis Štogl, Jack Center, Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 29 Apr 2022 00:00:00 -0000

ros-kilted-controller-manager (2.6.0-1noble) noble; urgency=high

  * Add controller_manager_msgs dependency to test_hardware_management_srvs (#702 <https://github.com/ros-controls/ros2_control/issues/702>)
  * Remove unused variable from the test (#700 <https://github.com/ros-controls/ros2_control/issues/700>)
  * Enable namespaces for controllers. (#693 <https://github.com/ros-controls/ros2_control/issues/693>)
  * Spawner waits for services (#683 <https://github.com/ros-controls/ros2_control/issues/683>)
  * Contributors: Denis Štogl, Rufus Wong, Tyler Weaver

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 20 Apr 2022 00:00:00 -0000

ros-kilted-controller-manager (2.5.0-1noble) noble; urgency=high

  * Make ControllerManager tests more flexible and reusable for different scenarios. Use more parameterized tests regarding strictness. (#661 <https://github.com/ros-controls/ros2_control/issues/661>)
  * Use lifecycle nodes in controllers again (#538 <https://github.com/ros-controls/ros2_control/issues/538>)
    * Add lifecycle nodes
    * Add custom 'configure' to controller interface to get 'update_rate' parameter.
    * Disable external interfaces of LifecycleNode.
  * Small fixes in controller manager tests. (#660 <https://github.com/ros-controls/ros2_control/issues/660>)
  * Enable controller manager services to control hardware lifecycle #abi-breaking (#637 <https://github.com/ros-controls/ros2_control/issues/637>)
    * Implement CM services for hardware lifecycle management.
    * Added default behavior to activate all controller and added description of CM parameters.
  * Contributors: Denis Štogl, Vatan Aksoy Tezer, Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 25 Mar 2022 00:00:00 -0000

ros-kilted-controller-manager (2.4.0-1noble) noble; urgency=high

  * Fixes of issue with seg-fault when checking interfaces on unconfigured controllers. (#580 <https://github.com/ros-controls/ros2_control/issues/580>)
  * Update CM service QoS so that we don't lose service calls when using many controllers. (#643 <https://github.com/ros-controls/ros2_control/issues/643>)
  * Contributors: Denis Štogl, Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 23 Feb 2022 00:00:00 -0000

ros-kilted-controller-manager (2.3.0-1noble) noble; urgency=high

  * added a fixed control period to loop (#647 <https://github.com/ros-controls/ros2_control/issues/647>)
  * install spawner/unspawner using console_script entrypoint (#607 <https://github.com/ros-controls/ros2_control/issues/607>)
  * Add BEST_EFFORT in the controller switch tests. (#582 <https://github.com/ros-controls/ros2_control/issues/582>)
  * Resolve unused parameter warnings (#636 <https://github.com/ros-controls/ros2_control/issues/636>)
  * Contributors: Bence Magyar, Denis Štogl, Jack Center, Melvin Wang, Xi-Huang

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 18 Feb 2022 00:00:00 -0000

ros-kilted-controller-manager (2.2.0-1noble) noble; urgency=high

  * Resource Manager API changes for hardware lifecycle #api-breaking #abi-breaking (#589 <https://github.com/ros-controls/ros2_control/issues/589>)
    * Towards selective starting and stoping of hardware components. Cleaning and renaming.
    * Move Lifecycle of hardware component to the bottom for better overview.
    * Use the same nomenclature as for controllers. 'start' -> 'activate'; 'stop' -> 'deactivate'
    * Add selective starting and stopping of hardware resources.
    Add HardwareComponentInfo structure in resource manager.
    Use constants for HW parameters in tests of resource_manager.
    Add list hardware components in CM to get details about them and check their status.
    Use clear name for 'guard' and move release cmd itfs for better readability.
    RM: Add lock for accesing maps with stored interfaces.
    Separate hardware components-related services after controllers-related services.
    Add service for activate/deactive hardware components.
    Add activation and deactivation through ResourceStorage. This helps to manage available command interfaces.
    * Use lifecycle_msgs/State in ListHardwareCompoents for state representation.
    * Simplify repeatable code in methods.
    * Add HW shutdown structure into ResouceManager.
    * Fill out service callback in CM and add parameter for auto-configure.
    * Move claimed_command_itf_map to ResourceStorage from ResourceManager.
    * Do not automatically configure hardware in RM.
    * Lifecycle and claiming in Resource Manager is working.
    * Extend controller manager to support HW lifecycle.
    * Add also available and claimed status into list components service output.
    * Add SetHardwareComponentState service.
    * Make all output in services debug-output.
    * Remove specific services for hardware lifecycle management and leave only 'set_hardware_component_state' service.
    * Make init_resource_manager less stateful.
    * Keep old api to start/activate all components per default.
    * Remove 'moving'/'non-moving' interface-handling.
    * Remove obsolete 'import_components' methods without hardware info and fix post_initialization test.
    Co-authored-by: Bence Magyar <mailto:bence.magyar.robotics@gmail.com>
  * Contributors: Denis Štogl

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 24 Jan 2022 00:00:00 -0000

ros-kilted-controller-manager (2.1.0-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 11 Jan 2022 00:00:00 -0000

ros-kilted-controller-manager (2.0.0-1noble) noble; urgency=high

  * Add service-skeletons for controlling hardware lifecycle. (#585 <https://github.com/ros-controls/ros2_control/issues/585>)
  * fix get_update_rate visibility in windows (#586 <https://github.com/ros-controls/ros2_control/issues/586>)
  * Make output of not available controller nicer and make it informational. (#577 <https://github.com/ros-controls/ros2_control/issues/577>)
  * Contributors: Denis Štogl, Melvin Wang

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 29 Dec 2021 00:00:00 -0000

ros-kilted-controller-manager (1.2.0-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 05 Nov 2021 00:00:00 -0000

ros-kilted-controller-manager (1.1.0-1noble) noble; urgency=high

  * feat: add colored output into spawner.py (#560 <https://github.com/ros-controls/ros2_control/issues/560>)
  * Added timeout argument for service_caller timeout (#552 <https://github.com/ros-controls/ros2_control/issues/552>)
  * controller_manager: Use command_interface_configuration for the claimed interfaces when calling list_controllers (#544 <https://github.com/ros-controls/ros2_control/issues/544>)
  * Clean up test_load_controller (#532 <https://github.com/ros-controls/ros2_control/issues/532>)
  * Contributors: Jack Center, Jafar Abdi, Michael, Nour Saeed

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 25 Oct 2021 00:00:00 -0000

ros-kilted-controller-manager (1.0.0-1noble) noble; urgency=high

  * Use ControllerManager node clock for control loop timepoints (#542 <https://github.com/ros-controls/ros2_control/issues/542>)
  * Per controller update rate(#513 <https://github.com/ros-controls/ros2_control/issues/513>)
  * added dt to controller interface and controller manager #438 <https://github.com/ros-controls/ros2_control/issues/438> (#520 <https://github.com/ros-controls/ros2_control/issues/520>)
  * Update nomenclature in CM for better code and output understanding (#517 <https://github.com/ros-controls/ros2_control/issues/517>)
  * Methods controlling the lifecycle of controllers all have on_ prefix
  * Controller Manager should not crash when trying to start finalized or unconfigured controller (#461 <https://github.com/ros-controls/ros2_control/issues/461>)
  * Fix deprecation warning from rclcpp::Duration (#511 <https://github.com/ros-controls/ros2_control/issues/511>)
  * Remove BOOST compiler definitions for pluginlib from CMakeLists (#514 <https://github.com/ros-controls/ros2_control/issues/514>)
  * Do not manually set C++ version to 14 (#516 <https://github.com/ros-controls/ros2_control/issues/516>)
  * Refactor INSTANTIATE_TEST_CASE_P -> INSTANTIATE_TEST_SUITE_P (#515 <https://github.com/ros-controls/ros2_control/issues/515>)
    Also removed the duplicated format & compiler fixes as on Galactic this shouldn't be an issue
  * rename get_current_state() to get_state() (#512 <https://github.com/ros-controls/ros2_control/issues/512>)
  * Fix spawner tests (#509 <https://github.com/ros-controls/ros2_control/issues/509>)
  * Removed deprecated CLI verbs (#420 <https://github.com/ros-controls/ros2_control/issues/420>)
  * Remove extensions from executable nodes (#453 <https://github.com/ros-controls/ros2_control/issues/453>)
  * Contributors: Bence Magyar, Denis Štogl, Dmitri Ignakov, Joseph Schornak, Márk Szitanics, Tim Clephas, bailaC, Mathias Aarbo

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 29 Sep 2021 00:00:00 -0000

ros-kilted-controller-manager (0.8.0-1noble) noble; urgency=high

  * Use clang format as code formatter (#491 <https://github.com/ros-controls/ros2_control/issues/491>)
  * Use example urdf from the test_assests package. (#495 <https://github.com/ros-controls/ros2_control/issues/495>)
  * Separate controller manager test cases (#476 <https://github.com/ros-controls/ros2_control/issues/476>)
  * Add Controller Manager docs (#467 <https://github.com/ros-controls/ros2_control/issues/467>)
  * sort interfaces in resource manager (#483 <https://github.com/ros-controls/ros2_control/issues/483>)
  * Add pre-commit setup. (#473 <https://github.com/ros-controls/ros2_control/issues/473>)
  * Make controller_manager set controller's use_sim_time param when use_sim_time=True (#468 <https://github.com/ros-controls/ros2_control/issues/468>)
    * potential solution to controller_manager use_sim_time sharing issue
    * removed debug print statements
    * added INFO message to warn user that use_sim_time is being set automatically
  * Add load-only option into controller spawner (#427 <https://github.com/ros-controls/ros2_control/issues/427>)
  * Fixes for windows (#443 <https://github.com/ros-controls/ros2_control/issues/443>)
    * Fix building on windows
    * Fix MSVC linker error when building tests
    * Fix hang when loading controller on windows
    * Use better log for configuring controller
    * Be consistent with visibility control
    * Use try_lock throw exception on failure
  * Add an argument to define controller manager timeout (#444 <https://github.com/ros-controls/ros2_control/issues/444>)
  * Contributors: Akash, Bence Magyar, Darko Lukić, Denis Štogl, Karsten Knese, Simon Honigmann

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 28 Aug 2021 00:00:00 -0000

ros-kilted-controller-manager (0.7.1-1noble) noble; urgency=high

  * Use namespace in controller_manager (#435 <https://github.com/ros-controls/ros2_control/issues/435>)
  * Contributors: Jonatan Olofsson

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 15 Jun 2021 00:00:00 -0000

ros-kilted-controller-manager (0.7.0-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 06 Jun 2021 00:00:00 -0000

ros-kilted-controller-manager (0.6.1-1noble) noble; urgency=high

  * Add missing dependency on controller_manager_msgs (#426 <https://github.com/ros-controls/ros2_control/issues/426>)
  * Contributors: Denis Štogl

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 31 May 2021 00:00:00 -0000

ros-kilted-controller-manager (0.6.0-1noble) noble; urgency=high

  * List controller claimed interfaces (#407 <https://github.com/ros-controls/ros2_control/issues/407>)
    * List controllers now also shows the claimed interfaces
    * Fixed tests that perform switches
    Successfull controller switches require more than one call to update()
    in order to update the controller list
    * Can now set the command interface configuration
    * Added checks for the claimed interfaces
  * Contributors: Jordan Palacios

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 23 May 2021 00:00:00 -0000

ros-kilted-controller-manager (0.5.0-1noble) noble; urgency=high

  * Make controller manager update rate optional (#404 <https://github.com/ros-controls/ros2_control/issues/404>)
  * Bump wait_for_service timeout to 10 seconds (#403 <https://github.com/ros-controls/ros2_control/issues/403>)
  * introduce --stopped for spawner (#402 <https://github.com/ros-controls/ros2_control/issues/402>)
  * hardware_interface mode switching using prepareSwitch doSwitch approach (#348 <https://github.com/ros-controls/ros2_control/issues/348>)
  * Avoid std::stringstream (#391 <https://github.com/ros-controls/ros2_control/issues/391>)
  * avoid deprecations (#393 <https://github.com/ros-controls/ros2_control/issues/393>)
  * Use RCLCPP_DEBUG_STREAM for char * (#389 <https://github.com/ros-controls/ros2_control/issues/389>)
  * Check controller_interface::init return value when loading (#386 <https://github.com/ros-controls/ros2_control/issues/386>)
  * Do not throw when controller type is not found, return nullptr instead (#387 <https://github.com/ros-controls/ros2_control/issues/387>)
  * Contributors: Auguste Bourgois, Karsten Knese, Matt Reynolds, Tyler Weaver, Mathias Hauan Arbo, Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 03 May 2021 00:00:00 -0000

ros-kilted-controller-manager (0.4.0-1noble) noble; urgency=high

  * Fix deprecation warnings: SUCCESS -> OK (#375 <https://github.com/ros-controls/ros2_control/issues/375>)
  * Don't use FileType for param-file (#351 <https://github.com/ros-controls/ros2_control/issues/351>)
  * Remodel ros2controlcli, refactor spawner/unspawner and fix test (#349 <https://github.com/ros-controls/ros2_control/issues/349>)
  * Add spawner and unspawner scripts (#310 <https://github.com/ros-controls/ros2_control/issues/310>)
  * Contributors: Bence Magyar, Jordan Palacios, Karsten Knese, Victor Lopez

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 07 Apr 2021 00:00:00 -0000

ros-kilted-controller-manager (0.3.0-1noble) noble; urgency=high

  * release_interfaces when stopping controller (#343 <https://github.com/ros-controls/ros2_control/issues/343>)
    * release_interfaces when stopping controller
    * Moved release_interfaces after deactivate
    * First attempt at test_release_interfaces
    * Switched to std::async with cm_->update
  * Capatalized error message and put the controllers name and resource name inside quote (#338 <https://github.com/ros-controls/ros2_control/issues/338>)
  * Contributors: mahaarbo, suab321321

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 21 Mar 2021 00:00:00 -0000

ros-kilted-controller-manager (0.2.1-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 02 Mar 2021 00:00:00 -0000

ros-kilted-controller-manager (0.2.0-1noble) noble; urgency=high

  * Add "Fake" components for simple integration of framework (#323 <https://github.com/ros-controls/ros2_control/issues/323>)
  * Contributors: Denis Štogl

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 26 Feb 2021 00:00:00 -0000

ros-kilted-controller-manager (0.1.6-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 05 Feb 2021 00:00:00 -0000

ros-kilted-controller-manager (0.1.5-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 04 Feb 2021 00:00:00 -0000

ros-kilted-controller-manager (0.1.4-1noble) noble; urgency=high

  * fix float conversion warning (#312 <https://github.com/ros-controls/ros2_control/issues/312>)
  * update doxygen style according to ros2 core standard (#300 <https://github.com/ros-controls/ros2_control/issues/300>)
  * Capitalized messages in controller_manager.cpp upto line669 (#285 <https://github.com/ros-controls/ros2_control/issues/285>)
  * Sleep accurate duration on ros2_control_node (#302 <https://github.com/ros-controls/ros2_control/issues/302>)
  * Contributors: Achinta-Choudhury, João Victor Torres Borges, Karsten Knese, Yutaka Kondo

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 03 Feb 2021 00:00:00 -0000

ros-kilted-controller-manager (0.1.3-1noble) noble; urgency=high

  * Fix building on macOS with clang (#292 <https://github.com/ros-controls/ros2_control/issues/292>)
  ail.com>
  * Contributors: Karsten Knese

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 21 Jan 2021 00:00:00 -0000

ros-kilted-controller-manager (0.1.2-1noble) noble; urgency=high

  * Fix update rate issues by working around MutliThreadedExecutor (#275 <https://github.com/ros-controls/ros2_control/issues/275>)
    * Fix update rate issues by working around MutliThreadedExecutor
    Currently the MutliThreadedExecutor performance is very bad. This leads
    to controllers not meeting their update rate. This PR is a temporary
    workaround for these issues.
    The current approach uses a rclcpp timer to execute the control loop.
    When used in combination with the MutliThreadedExecutor, the timers
    are not execute at their target frequency. I've converted the control
    loop to a while loop on a separate thread that uses nanosleep to
    execute the correct update rate. This means that rclcpp is not
    involved in the execution and leads to much better performance.
    * Address review comments by rewriting several comments
  * Contributors: Ramon Wijnands

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 06 Jan 2021 00:00:00 -0000

ros-kilted-controller-manager (0.1.1-1noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 23 Dec 2020 00:00:00 -0000

ros-kilted-controller-manager (0.1.0-1noble) noble; urgency=high

  * Add configure controller service (#272 <https://github.com/ros-controls/ros2_control/issues/272>)
  * Remove lifecycle node (#261 <https://github.com/ros-controls/ros2_control/issues/261>)
  * Added starting of resources into CM and RM (#240 <https://github.com/ros-controls/ros2_control/issues/240>)
  * Use resource manager (#236 <https://github.com/ros-controls/ros2_control/issues/236>)
  * Remove pluginlib warnings on reload test (#237 <https://github.com/ros-controls/ros2_control/issues/237>)
  * resource loaning (#224 <https://github.com/ros-controls/ros2_control/issues/224>)
  * Allocate memory for components and handles (#207 <https://github.com/ros-controls/ros2_control/issues/207>)
  * Add controller manager services (#139 <https://github.com/ros-controls/ros2_control/issues/139>)
  * Change Hardware return type to enum class (#114 <https://github.com/ros-controls/ros2_control/issues/114>)
  * Use rclcpp::Executor instead of rclcpp::executor::Executor(deprecated) (#82 <https://github.com/ros-controls/ros2_control/issues/82>)
  * Replace RCUTILS_ with RCLCPP_ for logging (#62 <https://github.com/ros-controls/ros2_control/issues/62>)
  * dont include pluginlib header in controller manager header (#63 <https://github.com/ros-controls/ros2_control/issues/63>)
  * export controller_interface (#58 <https://github.com/ros-controls/ros2_control/issues/58>)
  * Use pluginlib instead of class_loader for loading controllers (#41 <https://github.com/ros-controls/ros2_control/issues/41>)
  * import controller_manager
  * Contributors: Bence Magyar, Denis Štogl, Jafar Abdi, Jordan Palacios, Karsten Knese, Parth Chopra, Victor Lopez

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 22 Dec 2020 00:00:00 -0000


